//
//  Services.h
//  ATIKOSXDrivers
//
//  Created by Nick Kitchener on 04/11/2012.
//  Copyright (c) 2012 ATIK. All rights reserved.
//

//#import <Foundation/Foundation.h>
#import "ServiceInterface.h"
#import "Imager100.h"
#import "FilterWheel100.h"

// An interface to discover, claim and release services.

@protocol Services <NSObject>

// List all available (non-claimed services)
// Returns a dictionary set of (serviceIdentifier->Protocol)
-(NSDictionary*)availableServices;

// Claim a service instance of the given name for exclusive use.
-(id<ServiceInterface>)claimService:(NSString*)serviceIdentifier;

// Release the previously claimed service instance.
-(void)releaseService:(id<ServiceInterface>)serviceInstance;

@end
